searchNodes=[{"doc":"The configuration for mate deployments is stored in your applications root directory, in a file named .mate.exs . This uses import Config as you might already be used to. To get started you can use the mix task mix mate.init to help generate one for you. The configuration exists out of two parts: 1. Mate configuration This configures mate itself, a full example would be: config :mate , otp_app : :my_app , driver : Mate.Driver.SSH , mix_env : :prod , clean_paths : ~w{_build rel priv/generated priv/static} You can also customise the build steps that are executed, but more information about that can be found in Mate.Pipeline . 2. Remote configuration You can specify one or more remotes, for example you could configure a staging and production environment. But you can add as many as you want, with whichever names you want to use. A remote ends up as a %Mate.Remote{} struct, so a very complete example is: config :staging , build_server : &quot;build.example.com&quot; , deploy_server : &quot;www.example.com&quot; , build_path : &quot;/tmp/build/my-app&quot; , release_path : &quot;/opt/my-app&quot; , build_secrets : %{ &quot;prod.secret.exs&quot; =&gt; &quot;/home/elixir/secrets/prod.secret.exs&quot; } If both servers are the same you can also opt to just configure server instead of having to specify both build_server and deploy_server . For small setups it might be more likely for you to not have a separate build server yet. config :staging , server : &quot;www.example.com&quot; , You can also specify multiple deploy servers by turning them into a list as such: config :staging , deploy_server : [ &quot;www1.example.com&quot; , &quot;www2.example.com&quot; , &quot;www3.example.com&quot; ]","ref":"Mate.Config.html","title":"Mate.Config","type":"module"},{"doc":"Find a specific remote in the given config, or if there was no specific search query given it will just return the first one found as the default. This will return as a tuple.","ref":"Mate.Config.html#find_remote/2","title":"Mate.Config.find_remote/2","type":"function"},{"doc":"Find a specific remote in the given config, or if there was no specific search query given it will just return the first one found as the default. This will return a Mate.Remote struct or raise an error when there was nothing found.","ref":"Mate.Config.html#find_remote!/2","title":"Mate.Config.find_remote!/2","type":"function"},{"doc":"Reads and parses the given configuration file.","ref":"Mate.Config.html#read!/1","title":"Mate.Config.read!/1","type":"function"},{"doc":"","ref":"Mate.Config.html#t:t/0","title":"Mate.Config.t/0","type":"type"},{"doc":"This is the behaviour for Mate Drivers. The idea behind supporting multiple drivers is allowing the user to decide how and where they want to build their application. By default it will use the SSH driver, but you can also use Docker or Local. It is also possible to write your own. For an example I recommend looking at Mate.Driver.SSH . NOTE: Deployments (after build) currently always use the Mate.Driver.SSH .","ref":"Mate.Driver.html","title":"Mate.Driver","type":"behaviour"},{"doc":"This one is optional and can be used to close the current connection, cleanup or whatever else might be needed.","ref":"Mate.Driver.html#c:close/1","title":"Mate.Driver.close/1","type":"callback"},{"doc":"Copy a file from remote to local","ref":"Mate.Driver.html#c:copy_from/3","title":"Mate.Driver.copy_from/3","type":"callback"},{"doc":"Copy a file from local to remote","ref":"Mate.Driver.html#c:copy_to/3","title":"Mate.Driver.copy_to/3","type":"callback"},{"doc":"Returns a description of the current host (defaults to context hostname)","ref":"Mate.Driver.html#c:current_host/1","title":"Mate.Driver.current_host/1","type":"callback"},{"doc":"Executes a command using the driver","ref":"Mate.Driver.html#c:exec/3","title":"Mate.Driver.exec/3","type":"callback"},{"doc":"Executes a script using the driver","ref":"Mate.Driver.html#c:exec_script/2","title":"Mate.Driver.exec_script/2","type":"callback"},{"doc":"Prepare the source for building, for example send it to the build server.","ref":"Mate.Driver.html#c:prepare_source/1","title":"Mate.Driver.prepare_source/1","type":"callback"},{"doc":"Starts the driver, for example create an SSH connection, start a docker container, or whatever else might be needed for your new session.","ref":"Mate.Driver.html#c:start/2","title":"Mate.Driver.start/2","type":"callback"},{"doc":"This module contains helper functions that can be used to execute commands on the local machine, or the remote machine using the configured driver ƒrom .mate.exs . It also have functions to copy files from or to the remote server. These helpers are automatically imported in a custom Mate.Pipeline.Step . For example: defmodule CustomHelloUser do use Mate.Pipeline.Step @impl true def run ( session ) do { :ok , user } = remote_cmd ( session , &quot;whoami&quot; ) IO . puts &quot;Hello &quot; &lt;&gt; user { :ok , session } end end","ref":"Mate.Helpers.html","title":"Mate.Helpers","type":"module"},{"doc":"Safely terminate connections and raises error","ref":"Mate.Helpers.html#bail/3","title":"Mate.Helpers.bail/3","type":"function"},{"doc":"Copy a file from the remote server to the local machine","ref":"Mate.Helpers.html#copy_from/3","title":"Mate.Helpers.copy_from/3","type":"function"},{"doc":"Copy a file from your local machine to the remote server","ref":"Mate.Helpers.html#copy_to/3","title":"Mate.Helpers.copy_to/3","type":"function"},{"doc":"Execute a command (with arguments) on the local machine","ref":"Mate.Helpers.html#local_cmd/3","title":"Mate.Helpers.local_cmd/3","type":"function"},{"doc":"Execute a script on the local machine","ref":"Mate.Helpers.html#local_script/2","title":"Mate.Helpers.local_script/2","type":"function"},{"doc":"Execute a command (with arguments) on the remote machine","ref":"Mate.Helpers.html#remote_cmd/3","title":"Mate.Helpers.remote_cmd/3","type":"function"},{"doc":"Execute a script on the remote machine","ref":"Mate.Helpers.html#remote_script/2","title":"Mate.Helpers.remote_script/2","type":"function"},{"doc":"This module keeps track of the build and deploy pipelines. It will use the given steps from your Mate.Config to either build or deploy your application on the specified servers. The default steps will attempt to sniff whether or not you are in need of the assets pipeline, which uses npm by default. The pipeline can be updated with custom steps using the configuration file .mate.exs , for example you can add a custom step module with the Mate.Pipeline.Step behaviour. config :mate , steps : fn steps , pipeline -&gt; pipeline . insert_before ( steps , Mate.Step.CleanBuild , CustomStep ) end , defmodule CustomStep do use Mate.Pipeline.Step @impl true def run ( session ) do IO . puts ( &quot;Execute my custom code&quot; ) { :ok , session } end end You can also use useful commands like local_cmd/2 , local_cmd/3 , local_script/2 , remote_cmd/2 , remote_cmd/3 , remote_script/2 , copy_from/3 and copy_to/3 to interact with the local machine or with the build server in various ways.","ref":"Mate.Pipeline.html","title":"Mate.Pipeline","type":"module"},{"doc":"Returns list of default build steps.","ref":"Mate.Pipeline.html#default_steps/0","title":"Mate.Pipeline.default_steps/0","type":"function"},{"doc":"Inserts a custom step in the given steps after a specific spec. Example: pipeline . insert_after ( steps , Mate.Step.CleanBuild , CustomStep )","ref":"Mate.Pipeline.html#insert_after/3","title":"Mate.Pipeline.insert_after/3","type":"function"},{"doc":"Inserts a custom step in the given steps before a specific spec. Example: pipeline . insert_before ( steps , Mate.Step.CleanBuild , CustomStep )","ref":"Mate.Pipeline.html#insert_before/3","title":"Mate.Pipeline.insert_before/3","type":"function"},{"doc":"Create a new Pipeline struct with default build steps","ref":"Mate.Pipeline.html#new/0","title":"Mate.Pipeline.new/0","type":"function"},{"doc":"Create a new Pipeline struct with custom steps","ref":"Mate.Pipeline.html#new/1","title":"Mate.Pipeline.new/1","type":"function"},{"doc":"Removes a specific step from the given steps. Example: pipeline . remove ( steps , Mate.Step.CleanBuild )","ref":"Mate.Pipeline.html#remove/2","title":"Mate.Pipeline.remove/2","type":"function"},{"doc":"Replaces a specific step with a custom step in the given steps Example: pipeline . replace ( steps , Mate.Step.CleanBuild , CustomStep )","ref":"Mate.Pipeline.html#replace/3","title":"Mate.Pipeline.replace/3","type":"function"},{"doc":"Runs all steps within a given session for the given context, using the driver from your configuration file. For build context it will use the build_server and for deploy context it will run on all deploy servers.","ref":"Mate.Pipeline.html#run/1","title":"Mate.Pipeline.run/1","type":"function"},{"doc":"Run a specific step within the current session.","ref":"Mate.Pipeline.html#run_step/2","title":"Mate.Pipeline.run_step/2","type":"function"},{"doc":"","ref":"Mate.Pipeline.html#t:step/0","title":"Mate.Pipeline.step/0","type":"type"},{"doc":"","ref":"Mate.Pipeline.html#t:steps/0","title":"Mate.Pipeline.steps/0","type":"type"},{"doc":"","ref":"Mate.Pipeline.html#t:t/0","title":"Mate.Pipeline.t/0","type":"type"},{"doc":"This behaviour is used for every step in the pipeline","ref":"Mate.Pipeline.Step.html","title":"Mate.Pipeline.Step","type":"behaviour"},{"doc":"Run this step within the given session","ref":"Mate.Pipeline.Step.html#c:run/1","title":"Mate.Pipeline.Step.run/1","type":"callback"},{"doc":"This module stores all information about a remote. A remote in mate is your server environment, e.g. staging or production.","ref":"Mate.Remote.html","title":"Mate.Remote","type":"module"},{"doc":"Creates a new Mate.Remote stuct with the given id and parameters.","ref":"Mate.Remote.html#new/2","title":"Mate.Remote.new/2","type":"function"},{"doc":"","ref":"Mate.Remote.html#t:t/0","title":"Mate.Remote.t/0","type":"type"},{"doc":"This module contains all relevant information to the current session when running the mate.deploy mix task. It keeps track of the current configuration, build pipeline, assigns that can be used to transfer information between build steps, the current context to determine wheter this is a building session or a deploying session, and more!","ref":"Mate.Session.html","title":"Mate.Session","type":"module"},{"doc":"Creates a new Mate.Session struct based on the given config file and optionally any other options can be set.","ref":"Mate.Session.html#new/2","title":"Mate.Session.new/2","type":"function"},{"doc":"","ref":"Mate.Session.html#t:t/0","title":"Mate.Session.t/0","type":"type"},{"doc":"This is the behaviour for Mate Storage engines The idea behind supporting multiple storage engines is allowing the user to decide how and where they want to upload their completed builds. By default it will upload and download using SCP but for example you might be interested in using S3 or any other source.","ref":"Mate.Storage.html","title":"Mate.Storage","type":"behaviour"},{"doc":"Close the connection to your storage host.","ref":"Mate.Storage.html#c:close/1","title":"Mate.Storage.close/1","type":"callback"},{"doc":"Connect to your storage host.","ref":"Mate.Storage.html#c:connect/1","title":"Mate.Storage.connect/1","type":"callback"},{"doc":"","ref":"Mate.Storage.html#download/2","title":"Mate.Storage.download/2","type":"function"},{"doc":"Downloads the given file from storage to the deploy host(s)","ref":"Mate.Storage.html#c:download/2","title":"Mate.Storage.download/2","type":"callback"},{"doc":"","ref":"Mate.Storage.html#upload/2","title":"Mate.Storage.upload/2","type":"function"},{"doc":"Upload the given file from the build server to storage.","ref":"Mate.Storage.html#c:upload/2","title":"Mate.Storage.upload/2","type":"callback"},{"doc":"This BuildServer Storage module can be used to store your release archives somewhere on the build-server. There could be a variety of reasons to want this, for example you could be building and deploying on the same server for small hobby projects, have a mounted network share where you want to store your release archives or perhaps hand it off to another script/program to continue your deployment pipeline, just to name a few example use cases. How to use Configure your .mate.exs to use this module: config :mate , storage : Mate.Storage.BuildServer , storage_opts : [ release_dir : &quot;/path/to/releases/&quot; ]","ref":"Mate.Storage.BuildServer.html","title":"Mate.Storage.BuildServer","type":"module"},{"doc":"This storage driver will store your release archives to your local machine, and upload them to the deploy servers from your local machine as well. To use this module you can specify it in your .mate.exs module, however currently Mate.Storage.Local is the default so it is optional. In your .mate.exs you can specify it as such: config :mate , storage : Mate.Storage.Local By default this will copy the release archive to the project root, from where you are running the mate commands. However, you can optionally configure the local storage driver to store them in another directory. config :mate , storage_opts : [ release_dir : &quot;/path/to/dir&quot; ] NOTE This can also be relative, from the current working directory.","ref":"Mate.Storage.Local.html","title":"Mate.Storage.Local","type":"module"},{"doc":"This S3 Storage module can be used to store your release archives in a S3 bucket. This does require the addition of ex_aws and ex_aws_s3 in your mix.exs file, Mate does not have them as direct dependencies. How to use To add them update your mix.exs file with: def deps do [ { :ex_aws , &quot;~&gt; 2.0&quot; , only : :dev } , { :ex_aws_s3 , &quot;~&gt; 2.0&quot; , only : :dev } ] end NOTE If you use ExAws in your own project, you can of course omit the only: :dev part here. Then configure your .mate.exs to use this module: config :mate , storage : Mate.Storage.S3 , storage_opts : [ bucket : &quot;mate-releases&quot; , prefix : &quot;my/prefix/&quot; ] , The storage_opts can also be used to set any ex_aws configuration you might want to change. It just forwards all values to ExAws.Config.new(:s3, storage_opts) storage_opts : [ bucket : &quot;mate-releases&quot; , prefix : &quot;my/prefix/&quot; , region : &quot;eu-east-1&quot; , access_key_id : System . fetch_env! ( &quot;AWS_ACCESS_KEY&quot; ) , secret_access_key : System . fetch_env! ( &quot;AWS_SECRET_ACCESS_KEY&quot; ) ] , How does it work? It will create presigned requests for uploading or downloading on the local machine that runs mate , and then send them for upload/download using cURL on either the build server or the deploy servers.","ref":"Mate.Storage.S3.html","title":"Mate.Storage.S3","type":"module"},{"doc":"This module contains some small helper utilities.","ref":"Mate.Utils.html","title":"Mate.Utils","type":"module"},{"doc":"Returns a boolean to determine if the given value is empty. Examples: iex&gt; Mate.Utils.empty?(&quot;&quot;) true iex&gt; Mate.Utils.empty?([]) true iex&gt; Mate.Utils.empty?(nil) true iex&gt; Mate.Utils.empty?(&quot;Hello&quot;) false iex&gt; Mate.Utils.empty?([1,2,3]) false","ref":"Mate.Utils.html#empty?/1","title":"Mate.Utils.empty?/1","type":"function"},{"doc":"Returns the namespace Module name from the current Mix Project. Example: iex&gt; Mate.Utils . module ( ) &quot;Mate&quot;","ref":"Mate.Utils.html#module/0","title":"Mate.Utils.module/0","type":"function"},{"doc":"Returns the sanitized module name as a string. Example: iex&gt; Mate.Utils . module_name ( Mate ) &quot;Mate&quot; iex&gt; Mate.Utils . module_name ( % Mate.Pipeline { } ) &quot;Mate.Pipeline&quot; iex&gt; Mate.Utils . module_name ( &quot;Elixir.Mate&quot; ) &quot;Mate&quot;","ref":"Mate.Utils.html#module_name/1","title":"Mate.Utils.module_name/1","type":"function"},{"doc":"Returns the otp app from the current Mix Project. Example: iex&gt; Mate.Utils . otp_app ( ) :mate","ref":"Mate.Utils.html#otp_app/0","title":"Mate.Utils.otp_app/0","type":"function"},{"doc":"Returns a random id of any given length Examples: iex&gt; Mate.Utils.random_id() &quot;3T440PTEM1IFD64I9R8MU2L2TIAGSF1TRQDH394HCUS5IRJHCGL0&quot; iex&gt; Mate.Utils.random_id(6) &quot;HGEE0AFSH0&quot;","ref":"Mate.Utils.html#random_id/1","title":"Mate.Utils.random_id/1","type":"function"},{"doc":"Prints Mate tasks and their information. mix mate","ref":"Mix.Tasks.Mate.html","title":"Mix.Tasks.Mate","type":"task"},{"doc":"Builds a new release only, no deploying. Command line options -v , --verbose - increases verbosity level (more output!)","ref":"Mix.Tasks.Mate.Build.html","title":"Mix.Tasks.Mate.Build","type":"task"},{"doc":"Displays the current configuration of .mate.exs","ref":"Mix.Tasks.Mate.Config.html","title":"Mix.Tasks.Mate.Config","type":"task"},{"doc":"Builds a new release and deploys it too Command line options -v , --verbose - increases verbosity level (more output!)","ref":"Mix.Tasks.Mate.Deploy.html","title":"Mix.Tasks.Mate.Deploy","type":"task"},{"doc":"Creates a new mate configuration file (.mate.exs) Command line options --docker - create file with Docker driver as default --local - create file with Local driver as default -f , --force - force create file, overwrite if one already exists","ref":"Mix.Tasks.Mate.Init.html","title":"Mix.Tasks.Mate.Init","type":"task"},{"doc":"The Test driver is used for testing.","ref":"Mate.Driver.Test.html","title":"Mate.Driver.Test","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Mate.Driver.Test.html#child_spec/1","title":"Mate.Driver.Test.child_spec/1","type":"function"},{"doc":"","ref":"Mate.Driver.Test.html#response_for/3","title":"Mate.Driver.Test.response_for/3","type":"function"},{"doc":"","ref":"Mate.Driver.Test.html#sandbox/1","title":"Mate.Driver.Test.sandbox/1","type":"function"},{"doc":"The Docker driver is used to execute commands via Docker. Configure the image you want to use by setting it in the driver_opts Keyword list in your .mate.exs configuration file. For example: config :mate , driver : Mate.Driver.Docker , driver_opts : [ image : &quot;bitwalker/alpine-elixir-phoenix&quot; ] It will mount your current repository in /repo , but it will clone your latest commit to the specified build_path . If you have a secret file you want locally you can link it from /repo . For example: config :staging , server : &quot;www.example.com&quot; , build_path : &quot;/tmp/mate/my-app&quot; , build_secrets : %{ &quot;prod.secret.exs&quot; =&gt; &quot;/repo/config/prod.secret.exs&quot; }","ref":"Mate.Driver.Docker.html","title":"Mate.Driver.Docker","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Mate.Driver.Docker.html#child_spec/1","title":"Mate.Driver.Docker.child_spec/1","type":"function"},{"doc":"The Local driver is used to execute commands on your local machine. Be aware that if you want to deploy your application on another machine, they must match system architectures. For example if you build locally on MacOS you cannot deploy the application to Ubuntu. Example configuration: config :mate , otp_app : :example , module : Example , driver : Mate.Driver.Local config :staging , server : &quot;www.example.com&quot; , build_path : &quot;/tmp/mate/example&quot; , release_path : &quot;/home/elixir/releases/example&quot; , build_secrets : %{ &quot;prod.secret.exs&quot; =&gt; &quot; \#{ File . cwd! ( ) } /config/prod.secret.exs&quot; }","ref":"Mate.Driver.Local.html","title":"Mate.Driver.Local","type":"module"},{"doc":"The SSH driver is used to execute commands via SSH. It will maintain a connection using ControlMaster and send commands and/or files over that connection, instead of reconnecting for every given command.","ref":"Mate.Driver.SSH.html","title":"Mate.Driver.SSH","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Mate.Driver.SSH.html#child_spec/1","title":"Mate.Driver.SSH.child_spec/1","type":"function"},{"doc":"This removes the specified config.clean_paths .","ref":"Mate.Step.CleanBuild.html","title":"Mate.Step.CleanBuild","type":"module"},{"doc":"Copies the release tarball from storage to remote deploy servers.","ref":"Mate.Step.CopyToDeployHost.html","title":"Mate.Step.CopyToDeployHost","type":"module"},{"doc":"This copies the release tarball to storage.","ref":"Mate.Step.CopyToStorage.html","title":"Mate.Step.CopyToStorage","type":"module"},{"doc":"This will create symlinks for secret configuration files like prod.secret.exs so the build process can include them in the build. Configuration If you want to use this functionality, in your .mate.exs file you can specify this for every remote. For example like this: config :staging , server : &quot;build-server&quot; , build_path : &quot;/tmp/mate/project&quot; , release_path : &quot;/home/elixir/releases/project&quot; , build_secrets : %{ &quot;prod.secret.exs&quot; =&gt; &quot;/mnt/secrets/prod.secret.exs&quot; }","ref":"Mate.Step.LinkBuildSecrets.html","title":"Mate.Step.LinkBuildSecrets","type":"module"},{"doc":"This will run mix compile on the build server.","ref":"Mate.Step.MixCompile.html","title":"Mate.Step.MixCompile","type":"module"},{"doc":"This will install the mix dependencies.","ref":"Mate.Step.MixDeps.html","title":"Mate.Step.MixDeps","type":"module"},{"doc":"This will run mix phx.digest.clean and mix phx.digest on the build server.","ref":"Mate.Step.MixDigest.html","title":"Mate.Step.MixDigest","type":"module"},{"doc":"This will run mix release --overwrite on the build server.","ref":"Mate.Step.MixRelease.html","title":"Mate.Step.MixRelease","type":"module"},{"doc":"This will run npm run deploy on the build server.","ref":"Mate.Step.NpmBuild.html","title":"Mate.Step.NpmBuild","type":"module"},{"doc":"This will install the front-end dependencies using npm.","ref":"Mate.Step.NpmInstall.html","title":"Mate.Step.NpmInstall","type":"module"},{"doc":"This will prepare the source code for building, for example when using the Mate.Driver.SSH driver it will push the latest commit to the build server.","ref":"Mate.Step.PrepareSource.html","title":"Mate.Step.PrepareSource","type":"module"},{"doc":"This will push the current branch/commit to the build server.","ref":"Mate.Step.SendGitCommit.html","title":"Mate.Step.SendGitCommit","type":"module"},{"doc":"Starts or restarts the new release on the remote release servers.","ref":"Mate.Step.StartRelease.html","title":"Mate.Step.StartRelease","type":"module"},{"doc":"Starts or restarts the new release on the remote release servers.","ref":"Mate.Step.StopRelease.html","title":"Mate.Step.StopRelease","type":"module"},{"doc":"Unarchives the release tarball on the remote deploy servers.","ref":"Mate.Step.UnarchiveRelease.html","title":"Mate.Step.UnarchiveRelease","type":"module"},{"doc":"This will verify Elixir is available in PATH on the build server.","ref":"Mate.Step.VerifyElixir.html","title":"Mate.Step.VerifyElixir","type":"module"},{"doc":"This verifies git both on the local machine and the build server. Local Machine On your local machine it will ensure there is a git remote configured for the current remote (e.g. staging, production) to the build server. It will also get the name of the current branch on your local machine. Build Server On the build server it will ensure that the build path exists, that it is a git repository, that is is configured to receive commits, it is given a hard reset and checkout to the same branch that is currently used on the local machine.","ref":"Mate.Step.VerifyGit.html","title":"Mate.Step.VerifyGit","type":"module"},{"doc":"This will verify node is available in PATH on the build server.","ref":"Mate.Step.VerifyNode.html","title":"Mate.Step.VerifyNode","type":"module"},{"doc":"Overview Mate is a library you can add to your Elixir/Phoenix project to help you build it on remote servers via SSH, on Docker Images or just on your local machine. It is compareable to edeliver but actually written in Elixir instead of many, many Bash scripts. This enables you to create custom drivers for build strategies if the built-in ones (ssh, docker, local) are not enough, or custom steps if you want to perform additional commands while building your application. By default it will use mix release , which is available since Elixir 1.9. But using it with something like distillery should be fairly trivial and potentially support for this will be built-in to Mate in the near future.","ref":"overview.html","title":"Overview","type":"extras"},{"doc":"By default it will run the built-in steps for a standard Elixir application, if assets/package.json exists it will also run additional steps to install the dependencies and run the deploy and digest scripts for that as well. It does this on a clean copy of your current Git commit, if you have any (un)staged files that are not yet committed they will not be included in the release. Any secrets should be available in your build environment and can be symlinked via the configuration file. Based on your configured build strategy it will run the build steps on either a remote server via SSH, using a Docker image or on your local machine directly. Make sure you choose the right one because you can't compile cross-platform or cross-arch. The result of the build should be a tarball ( tar.gz ) that ends up in a Mate.Storage option of your choice, by default is uses Mate.Storage.Local which is just your project root on your local machine. Although you can configure a different directory as well. The other included storage modules are Mate.Storage.S3 and Mate.Storage.BuildServer to store on either S3 (using ex_aws ) or the build server where you build the release. It is also possible to write your own Mate.Storage module for any other storage needs . With mix mate.deploy it will also ask you if you want to deploy your newly built release. This will be sent to all configured deploy servers via ssh and automatically (re)started. This is optional. Want to try it out? Continue to Get Started","ref":"overview.html#how-does-it-work","title":"Overview - How does it work?","type":"extras"},{"doc":"Getting Started This guide will briefly explain how to get started with using Mate. It assumes you already have an Elixir project and a build and/or deploy server that you can access via SSH.","ref":"getting_started.html","title":"Getting Started","type":"extras"},{"doc":"Mate is available via https://hex.pm/packages/mate . Add mate to your dependencies in the mix.exs file, you only need it for :dev as you only use it to run locally from your machine. def deps do [ { :mate , &quot;~&gt; 0.1.8&quot; , only : :dev } ] end After adding this to your mix.exs file, run mix deps.get to download it and then continue.","ref":"getting_started.html#installation","title":"Getting Started - Installation","type":"extras"},{"doc":"All configuration will be stored in a file called .mate.exs and uses the default Config syntax from Elixir. To get you started Mate includes a task to create your configuration file using mix mate.init . You can optionally pass it some arguments to change it for your usecase. After running this command you should have a new .mate.exs file looking something like this: import Config config :mate , otp_app : :my_app , module : MyApp # This simple configuration will build and deploy to the same server config :staging , server : &quot;example.com&quot; , build_path : &quot;/tmp/mate/my_app&quot; , release_path : &quot;/opt/my_app&quot; , # Specify secret files, if they are already present on your build server. # config :staging, # build_secrets: %{ # &quot;prod.secret.exs&quot; =&gt; &quot;/mnt/secrets/prod.secret.exs&quot; # } # You can specify separate servers like this: # config :production, # build_server: &quot;build.example.com&quot;, # deploy_server: &quot;www.example.com&quot; # For `deploy_server` you can also set a list like this: # config :production, # deploy_server: [ # &quot;www1.example.com&quot;, # &quot;www2.example.com&quot; # ] The main things to configure are the server , build_path and release_path values. If needed you can also configure your secret files by linking them to files already on the build server. It is also possible to configure a separate build_server and deploy_server , the default server command expects them both to be the same value.","ref":"getting_started.html#first-time-configuration","title":"Getting Started - First time configuration","type":"extras"},{"doc":"While Elixir 1.9+ supports a default mix release task, it does not by default generate a .tar.gz file. This is what is needed for Mate to easily transfer the release between your build and deploy servers. So in your projects mix.exs file please make sure you enable the :tar step. defmodule MyProject.MixProject do use Mix.Project def project do [ app : :my_project , ... releases : [ my_project : [ include_executables_for : [ :unix ] , steps : [ :assemble , :tar ] ] ] , ...","ref":"getting_started.html#configure-mix-release","title":"Getting Started - Configure Mix Release","type":"extras"},{"doc":"Running mix mate.deploy will start the build process, based on your configuration file. What exactly happens there can be changed with custom steps . If something goes wrong Mate should return a useful error message, and if everything goes according to plan you should end up with a release tarball in your project directory. After building your release Mate will prompt you if you want to deploy this release to the configured deploy servers, if you do this it will first copy the release tarball to all configured deploy servers, stop the current release (if any), unarchive the new release and start the new release.","ref":"getting_started.html#first-release","title":"Getting Started - First release","type":"extras"},{"doc":"Hopefully everything worked, so what's next depends on what you want. There are some customization options available, different build strategies, all of which are described in this documentation.","ref":"getting_started.html#what-s-next","title":"Getting Started - What's next?","type":"extras"},{"doc":"Build Strategies Mate comes with three different build strategies built-in, this guide tries to explain them in brief. For all strategies it is important to note that releases are not made to be cross platform or architecture e.g. Building on arm and running om amd64 is not possible, just like building on MacOS and deploying to a Debian server won't work. Using the SSH strategy and a build server that is as closely similar to your deployment servers as possible is the recommended route. But there are plenty of valid reasons to want to use one of the other strategies. It is also possible to create your own strategy entirely by creating a custom driver .","ref":"build_strategies.html","title":"Build Strategies","type":"extras"},{"doc":"The default strategy is to build your application on a remote server via an SSH connection. First it will push the current commit to the build server via SSH, then it will connect to the SSH server once and keep the connection open to send commands and eventually download the release tarball, if everything went according to plan. This is probably the most common usecase, where you use a build server to prepare the release before you start deploying it to your actual server(s).","ref":"build_strategies.html#ssh-default","title":"Build Strategies - SSH (default)","type":"extras"},{"doc":"The Docker strategy can be used to build your application inside of a Docker container, it works mostly the same as SSH except it will use the Docker command line client start a new container, mounted to the project directory to then copy the latest commit and create the build in there until finally the release tarball is copied to your local disk. An important distinction here is that the resulting file is not a Docker image, if this is what you want it is recommended to use a Dockerfile .","ref":"build_strategies.html#docker","title":"Build Strategies - Docker","type":"extras"},{"doc":"The Local strategy can be used to run all the build steps on your local machine. There isn't really much added benefit to this over running the commands yourself directly, besides ensuring it is run on a clean copy of the latest commit and you just type one command instead of multiple. It is only useful if you will deploy your application on a similar platform/architecture as your local machine.","ref":"build_strategies.html#local","title":"Build Strategies - Local","type":"extras"},{"doc":"You can create your own strategy as well by creating a custom driver .","ref":"build_strategies.html#custom","title":"Build Strategies - Custom","type":"extras"},{"doc":"Storage Options Mate comes with three different storage modules built-in, this guide tries to explain them in brief.","ref":"storage_options.html","title":"Storage Options","type":"extras"},{"doc":"The default storage module ( Mate.Storage.Local ) will store the final release archive on your local machine, and when deploying it will upload it from your local machine to all deploy servers. By default it stores the file in the project root, however you can customise this by configuring the storage_opts in your .mate.exs file. config :mate , storage : Mate.Storage.Local , storage_opts : [ release_dir : &quot;/path/to/dir&quot; ]","ref":"storage_options.html#local-defaul","title":"Storage Options - Local (defaul)","type":"extras"},{"doc":"The S3 storage modules ( Mate.Storage.S3 ) can be used to store your release archives in a S3 bucket. This uses ex_aws to communicate with AWS, which you can configure using storage_opts in your .mate.exs file. All settings will be forwarded to the ex_aws configuration so you can easily change anything. The way it works is by generating presigned urls for both uploading and downloading, it will perform the actual upload to or download from S3 on the actual servers itself. config :mate , storage : Mate.Storage.S3 , storage_opts : [ bucket : &quot;mate-releases&quot; , prefix : &quot;my/prefix/&quot; , region : &quot;eu-east-1&quot; , access_key_id : System . fetch_env! ( &quot;AWS_ACCESS_KEY&quot; ) , secret_access_key : System . fetch_env! ( &quot;AWS_SECRET_ACCESS_KEY&quot; ) ]","ref":"storage_options.html#s3","title":"Storage Options - S3","type":"extras"},{"doc":"The build server module ( Mate.Storage.BuildServer ) can be used to store the release archives on the build server itself. It is basically just a &quot;local&quot; copy, but it makes it more difficult to deploy the release archive to other deploy servers than itself. It's useful for example when for small hobby projects where you build and deploy to the same server, use mounted network storage across your servers or want to hand off the release archive to another script/application on the build server to continue the rest of deployment for you, just to name a few example use cases. config :mate , storage : Mate.Storage.BuildServer , storage_opts : [ release_dir : &quot;/path/to/releases/&quot; ]","ref":"storage_options.html#buildserver","title":"Storage Options - BuildServer","type":"extras"},{"doc":"You can also create your own strategy by creating a custom storage module .","ref":"storage_options.html#custom","title":"Storage Options - Custom","type":"extras"},{"doc":"F.A.Q.","ref":"faq.html","title":"F.A.Q.","type":"extras"},{"doc":"Out of the box no, but perhaps you could make this work by building one ore more custom steps and replacing the default Mate.Step.MixRelease step.","ref":"faq.html#does-it-work-with-distillery","title":"F.A.Q. - Does it work with distillery?","type":"extras"},{"doc":"Out of the box no, but perhaps you could make this work by building one ore more custom steps .","ref":"faq.html#does-it-support-appups","title":"F.A.Q. - Does it support appups?","type":"extras"},{"doc":"Currently no, but this might be interesting to add for the future.","ref":"faq.html#does-it-support-auto-versioning","title":"F.A.Q. - Does it support auto-versioning?","type":"extras"},{"doc":"By itself no, you could maybe do something with a Dockerfile and using the Local driver but if your end goal is to create a docker image you might not even need Mate.","ref":"faq.html#can-it-help-create-a-docker-container","title":"F.A.Q. - Can it help create a Docker container?","type":"extras"},{"doc":"Custom Driver Module Mate by default ships with four driver modules; Mate.Driver.SSH , Mate.Driver.Docker , Mate.Driver.Local and finally Mate.Driver.Test which is used for testing. All code that is executed for building and copying the release tarball will be executed through the driver, deployments also happen through the driver but those will always be done via the Mate.Driver.SSH driver currently. For SSH this means it will maintain an active SSH connection and execute command and scripts over this active connection, for Docker it means it will start a new Docker container and keep it alive to execute commands and scripts, and locally just performs these steps on your local machine. If the default options don't suffice for your usecase, you can make your own!","ref":"custom_driver.html","title":"Custom Driver Module","type":"extras"},{"doc":"A driver should use the Mate.Driver behaviour, the documentation for that module explains all available functions. It can store the current connection after start/2 inside the Mate.Session as the conn property. The Mate.Session object will be passed along for every function so you can reference it, and pass data between steps by using assigns on the Mate.Session .","ref":"custom_driver.html#the-driver-behaviour","title":"Custom Driver Module - The Driver Behaviour","type":"extras"},{"doc":"Custom Storage Module Mate by default ships with three storage modules; Mate.Storage.Local , Mate.Storage.S3 and Mate.Storage.BuildServer . With these mate hopefully covers most scenarios, however if you have any desire for other storage solutions you can create your own storage module as well. The storage module is responsible for uploading and downloading release archives to the storage of your choice. For examples you should take a look at the included storage modules, they are pretty small and the Mate.Storage behaviour only has two required functions; upload and download.","ref":"custom_storage.html","title":"Custom Storage Module","type":"extras"},{"doc":"A storage module should use the Mate.Storage behaviour, the documentation for that module explains all available functions. defmodule Mate.Storage.Custom do use Mate.Storage @impl true def download ( session , file ) do download_from_your_storage ( file ) end @impl true def upload ( session , file ) do upload_to_your_storage ( file ) end end","ref":"custom_storage.html#the-storage-behaviour","title":"Custom Storage Module - The Storage Behaviour","type":"extras"},{"doc":"Custom Build Steps When you are creating a new build with Mate it does this in multiple steps, the default steps can be overridden completely or manipulated with a custom Mate.Pipeline in your .mate.exs configuration file.","ref":"custom_steps.html","title":"Custom Build Steps","type":"extras"},{"doc":"Custom steps should use the Mate.Pipeline.Step behaviour. When your step is called the run/1 function receives the current Mate.Session object. It should return the session object in an {:ok, session} tuple, or if something went wrong in your step it should return an error tuple with a descriptive error string {:error, &quot;My step failed because of reasons&quot;} . You can assign custom properties to your Mate.Session if you want to pass along data across multiple steps. defmodule CustomStep do use Mate.Pipeline.Step @impl true def run ( session ) do IO . puts ( &quot;Execute my custom code&quot; ) { :ok , session } end end","ref":"custom_steps.html#behaviour","title":"Custom Build Steps - Behaviour","type":"extras"},{"doc":"When you create a custom step, you need to customise the build steps to make sure it's included. You can define your own pipeline by just specifying a List of steps in your configuration file. config :mate , steps : [ VerifyElixir , PrepareSource , LinkBuildSecrets , CleanBuild , MixDeps , MixCompile , MixRelease , CopyToStorage ] But maybe you are happy enough with the default pipeline and just want to change it slightly, by adding, replacing or removing a step. You can do this with some useful functions from Mate.Pipeline like this: config :mate , steps : fn steps , pipeline -&gt; steps |&gt; pipeline . insert_before ( Mate.Step.CleanBuild , MyCustomStep ) end Other useful functions for this are insert_before/3 , insert_after/3 , replace/3 and remove/2 .","ref":"custom_steps.html#using-my-custom-step","title":"Custom Build Steps - Using my custom step","type":"extras"},{"doc":"By creating a custom step you could override built-in steps as well, for example if you don't want to use mix release but another system you could create a step that executes another build system and replace MixRelease . NOTE: For this example I should note that the MixRelease step itself should add an assign :release_archive containing a path to the release archive on the build server. If this is missing the system will show an error of course.","ref":"custom_steps.html#replace-a-built-in-step","title":"Custom Build Steps - Replace a built-in step","type":"extras"}]